<?php

/*
Released under the GNU General Public License

Felles kode for bruk av Bring Fraktguide (http://fraktguide.bring.no/) av Arne Unneland (http://www.unneland.com) i februar 2009. 
  - Modulen benytter Bring Fraktguide XML API. Dette er gratis og krever ikke registrering, men forutsetter aksept av bruksvilkr som er tilgjengelig p http://fraktguide.bring.no/. De som bruker denne modulen anbefales  registrere seg p Bring Fraktguide da kun registrerte brukere fr beskjed om endringer i underliggende tjenester. Anbefaler ogs  lese informasjon om XML API da det er noen forutsetninger for de prisene som presenteres. Bla. m pakkene vre forhndsmeldt m/EDI.
  - Denne modulen er et privat initativ og p ingen mte er et Bring eller Posten produkt. Modulen brukes p eget ansvar og dersom man finner feil er det bare  fikse + melde tilbake til forumet p Zen Cart Norge :-)
  - Modulen leverer fraktkostnad for angitt produkt, samt produkttekster, hjelpetekster og transporttid. Noe av dette vises i den enkelte fraktmodul og kan tilpasses til den enkeltes behov.
  - Merk at det er gjort forenklinger i Zen Cart rundt fraktberegning. Det. er bla. kun fysisk vekt p pakkene, mens mange pakker prises etter fraktberegnet vekt (volum). Dette br man ta hensyn til nr man setter opp vekten p varene sine.
	
  Tips til forbedringer av denne modulen:
  - Legge inn sttte for lengde, bredde og hyde p artiklene i Zen Cart og oppdatere modulen til  sende dette til Bring Fraktguide. Det vil gi hyere kvalitet p prisberegningen, bde ren pris og spesialgodstillegg.
  --- Inspirasjon: http://www.zen-cart.com/index.php?main_page=product_contrib_info&cPath=40_51&products_id=471
  - Utnytte mer av informasjonen som er tilgjengelig fra Fraktguiden. Som f.eks. hjelpetekster (tooltip), transporttid, forventet leveringsdato etc
  - Dersom du benytter flere fraktalternativer sender modulen et HTTP request til Bring Fraktguide for hvert alternativ. Dette gr raskt, men kan caches (man kan sprre om flere produkter samtidig)

*/


/*
Denne metoden henter XML fra Bring Fraktguide. Se dokumentasjon p XML API p http://fraktguide.bring.no/
*/
function getXmlForProducts($productCode, $from, $to, $weightInGrams) {
	$http = new httpClient();
	$http->timeout = 2;
	$request = join('&', array('from=' . $from,
                               'to=' . $to,
                               'weightInGrams=' . $weightInGrams));
	if ($http->Connect('fraktguide.bring.no', 80)) {
		$http->addHeader('Host', 'fraktguide.bring.no');
		$http->addHeader('User-Agent', 'Zen Cart');
		$http->addHeader('Connection', 'close');

		if ($http->Get('/fraktguide/products/' . $productCode . '/all.xml?' . $request)) {
			$body = $http->getBody();
		}
		$http->Disconnect();
    }
	if ($body != null) {
		return new SimpleXMLElement($body);
	}
	return null;
}

/*
Denne metoden henter ut verdier fra XML og legger inn de interessante i en array som kan benyttes i det enkelte fraktalternativ.
*/
function getValuesForProduct($productCode, $from, $to, $weight, $weightMassType = 'Kilo') {
	if ($weightMassType == 'Kilo') {
		$weightInGrams = round($weight * 1000);
	} else {
		$weightInGrams = round($weight);
	}
	$xml = getXmlForProducts($productCode, $from, $to, $weightInGrams);
	
	if ($xml != null) {
		$priceElement = $xml->xpath('/Package/Product[ProductId=\'' . $productCode. '\']/Price/PackagePriceWithoutAdditionalServices/AmountWithoutVAT');  //hent ut pris med moms
		$productNameElement = $xml->xpath('/Package/Product[ProductId=\'' . $productCode. '\']/GuiInformation/ProductName');  //offisielt produktnavn
		$displayNameElement = $xml->xpath('/Package/Product[ProductId=\'' . $productCode. '\']/GuiInformation/DisplayName');  //nettbutikkvennlig produktnavn
		$descriptionTextElement = $xml->xpath('/Package/Product[ProductId=\'' . $productCode. '\']/GuiInformation/DescriptionText');  //beskrivelsestekst
		$helpTextElement = $xml->xpath('/Package/Product[ProductId=\'' . $productCode. '\']/GuiInformation/HelpText');  //hjelpetekst
		$workingDaysElement = $xml->xpath('/Package/Product[ProductId=\'' . $productCode. '\']/ExpectedDelivery/WorkingDays');  //antall transportdager
		
		if ($priceElement != null) {
			$map = array(
				'cost' => floatval($priceElement[0]),
				'productname' => utf8_decode(strval($productNameElement[0])),
				'displayname' => utf8_decode(strval($displayNameElement[0])),
				'workingdays' => utf8_decode(strval($workingDaysElement[0])),
				'helptext' => utf8_decode(strval($helpTextElement[0])),
				'description' => utf8_decode(strval($descriptionTextElement[0])),
			);
		}
		//free memory - just in case...
		unset($xml);
		unset($priceElement);
		unset($productNameElement);
		unset($displayNameElement);
		unset($descriptionTextElement);
		unset($workingDaysElement);
	}
	return $map;
}

?>