<?php
/*
  Released under the GNU General Public License

  Denne applikasjonen er oprinnelig portert fra oscommerce av
  Ingvald Haaland - ingvald@haaland.net

  Senere omskrevet og forbedret av Rune Rasmussen - http://www.syntaxerror.no
  Bl.a. for  gi fraktberegning ogs for brukere som ikke er innlogget,
  eller ikke har oppgitt postnummer. Samt forbedret fraktberegning, lagt inn oversettelse m.m.
  
  Senere omskrevet av Arne Unneland (http://www.unneland.com) til  bruke Bring Fraktguide (http://fraktguide.bring.no) i februar 2009. 
  - Modulen benytter Bring Fraktguide XML API. Dette er gratis og krever ikke registrering, men forutsetter aksept av bruksvilkr som er tilgjengelig p http://fraktguide.bring.no/. De som bruker denne modulen anbefales  registrere seg p Bring Fraktguide da kun registrerte brukere fr beskjed om endringer i underliggende tjenester. Anbefaler ogs  lese informasjon om XML API da det er noen forutsetninger for de prisene som presenteres. Bla. m pakkene vre forhndsmeldt m/EDI.
  - Denne modulen er et privat initativ og p ingen mte er et Bring eller Posten produkt. Modulen brukes p eget ansvar og dersom man finner feil er det bare  fikse + melde tilbake til forumet p Zen Cart Norge :-)
  - Modulen leverer fraktkostnad for angitt produkt, samt produkttekster, hjelpetekster og transporttid. Noe av dette vises i den enkelte fraktmodul og kan tilpasses til den enkeltes behov.
  - Merk at det er gjort forenklinger i Zen Cart rundt fraktberegning. Det. er bla. kun fysisk vekt p pakkene, mens mange pakker prises etter fraktberegnet vekt (volum). Dette br man ta hensyn til nr man setter opp vekten p varene sine.
 
  Tips til forbedringer av denne modulen ligger i bring_fraktguide_common/bring_fraktguide_common.php
  
*/

//Only once - remove comment if you are not using bring_servicepakke.php
//include 'bring_fraktguide_common/bring_fraktguide_common.php';

class bringbpakkedor {
    var $code, $title, $description, $icon, $enabled, $weightMassType;


	// class constructor
    function bringbpakkedor() {
		global $order, $db;
		$this->code = 'bringbpakkedor';
		$this->title = MODULE_SHIPPING_BRING_BPAKKEDOR_TEXT_TITLE;
		$this->description = MODULE_SHIPPING_BRING_BPAKKEDOR_TEXT_DESCRIPTION;
		$this->icon = DIR_WS_TEMPLATES . 'template_default/images/icons/shipping_bring.gif';
		$this->tax_class = MODULE_SHIPPING_BRING_BPAKKEDOR_TAX_CLASS;
		$this->sort_order = MODULE_SHIPPING_BRING_BPAKKEDOR_SORT_ORDER;
		$this->weightMassType = MODULE_SHIPPING_BRING_BPAKKEDOR_WEIGHTMASSTYPE;


		if (zen_get_shipping_enabled($this->code)) {
		  $this->enabled = ((MODULE_SHIPPING_BRING_BPAKKEDOR_STATUS == 'True') ? true : false);
		}
		if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_BRING_BPAKKEDOR_ZONE > 0) ) {
			$check_flag = false;
			$check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_BRING_BPAKKEDOR_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
			while (!$check->EOF) {
				if ($check->fields['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
					$check_flag = true;
					break;
				}
				$check->MoveNext();
			}

			if ($check_flag == false) {
				$this->enabled = false;
			}
	    }
	}

	// class methods
    function quote($method = '') {

		global $addressvalues, $shipping_weight, $order, $shipping_num_boxes, $db;
		$fra_nr = SHIPPING_ORIGIN_ZIP;

		if ($order->delivery['postcode'] > 0 ) {
			$til_nr = $order->delivery['postcode'];
		} else {
			$til_nr = $fra_nr;
		}

		$kollivekt=$shipping_weight/$shipping_num_boxes; //del vekt p antall kolli
		$fraktArray = getValuesForProduct("BPAKKE_DOR-DOR", $fra_nr, $til_nr, $kollivekt, $this->weightMassType); //se bring_fraktguide_common.php for detaljer og forutsetninger
		if ($fraktArray != null) {
			$fraktpris = ceil($fraktArray['cost']*$shipping_num_boxes); //rund opp til nrmeste hele krone

			$this->quotes = array('id' => $this->code,
				'module' => $fraktArray['displayname'],
				'methods' => array(array('id' => $this->code,
								 'title' => $fraktArray['productname'], 
				'cost' => round(SHIPPING_HANDLING + $fraktpris))));
			if ($this->tax_class > 0) {
				$this->quotes['tax'] = zen_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
			}
			if (zen_not_null($this->icon)) $this->quotes['icon'] = zen_image($this->icon, $this->title);
		
			return $this->quotes;
		}

    }

    function check() {
		global $db;
		if (!isset($this->_check)) {
			$check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_BRING_BPAKKEDOR_STATUS'");
			$this->_check = $check_query->RecordCount();
		}
		return $this->_check;
    }

    function install() {
        global $db;
     	$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Aktivere', 'MODULE_SHIPPING_BRING_BPAKKEDOR_STATUS', 'True', 'Vil du tilby sending med denne fraktmetoden?', '6', '0', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Avgiftsklasse', 'MODULE_SHIPPING_BRING_BPAKKEDOR_TAX_CLASS', '0', 'Bruk flgende avgiftsklasse p fraktpris.', '6', '0', 'zen_get_tax_class_title' , 'zen_cfg_pull_down_tax_classes(', now())");
     	$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Produktvekt', 'MODULE_SHIPPING_BRING_BPAKKEDOR_WEIGHTMASSTYPE', 'Kilo', 'Er produktvekt oppgitt i kilo eller gram?', '6', '0', 'zen_cfg_select_option(array(\'Kilo\', \'Gram\'), ', now())");
		$db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Leveringssone', 'MODULE_SHIPPING_BRING_BPAKKEDOR_ZONE', '0', 'Om en sone er valgt vil fraktvalget bare vre tilgjengelig for denne sonen.', '6', '0', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sortering', 'MODULE_SHIPPING_BRING_BPAKKEDOR_SORT_ORDER', '0', 'Sorteringsrekkeflge ved visning.', '6', '0', now())");
    }

    function remove() {
		global $db;
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key ='MODULE_SHIPPING_BRING_BPAKKEDOR_STATUS'");
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key ='MODULE_SHIPPING_BRING_BPAKKEDOR_TAX_CLASS'");
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key ='MODULE_SHIPPING_BRING_BPAKKEDOR_WEIGHTMASSTYPE'");
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key ='MODULE_SHIPPING_BRING_BPAKKEDOR_ZONE'");
		$db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key ='MODULE_SHIPPING_BRING_BPAKKEDOR_SORT_ORDER'");
}

    function keys() {
    	return array('MODULE_SHIPPING_BRING_BPAKKEDOR_STATUS', 'SHIPPING_ORIGIN_ZIP', 'MODULE_SHIPPING_BRING_BPAKKEDOR_WEIGHTMASSTYPE', 'MODULE_SHIPPING_BRING_BPAKKEDOR_TAX_CLASS', 'MODULE_SHIPPING_BRING_BPAKKEDOR_ZONE','MODULE_SHIPPING_BRING_BPAKKEDOR_SORT_ORDER');
    }
}
?>
